diff a/src/hotspot/share/oops/recompilationSchedule.hpp b/src/hotspot/share/oops/recompilationSchedule.hpp
--- /dev/null
+++ b/src/hotspot/share/oops/recompilationSchedule.hpp
@@ -0,0 +1,76 @@
+/*
+ * Copyright (c) 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+
+#ifndef SHARE_OOPS_RECOMPILATION_SCHEDULE_HPP
+#define SHARE_OOPS_RECOMPILATION_SCHEDULE_HPP
+
+#include "cds/serializeClosure.hpp"
+#include "memory/allStatic.hpp"
+#include "memory/metaspaceClosure.hpp"
+#include "oops/array.hpp"
+#include "oops/trainingData.hpp"
+#include "runtime/atomic.hpp"
+#include "utilities/exceptions.hpp"
+#include "utilities/macros.hpp"
+#include "utilities/ostream.hpp"
+
+class RecompilationSchedule : public AllStatic {
+  static Array<MethodTrainingData*>* _schedule;
+  static Array<MethodTrainingData*>* _schedule_for_dumping;
+  static volatile bool* _status;
+public:
+  static void initialize();
+  static void prepare(TRAPS);
+  static bool have_schedule() { return _schedule != nullptr; }
+  static Array<MethodTrainingData*>* schedule() { return _schedule; }
+  static int length() {
+    return have_schedule() ? _schedule->length() : 0;
+  }
+  static MethodTrainingData* at(int i) {
+    assert(i < length(), "");
+    return schedule()->at(i);
+  }
+  static volatile bool* status() { return _status; }
+  static volatile bool* status_adr_at(int i) {
+    assert(i < length(), "");
+    return &_status[i];
+  }
+  static bool status_at(int i) {
+    return Atomic::load_acquire(status_adr_at(i));
+  }
+  static void set_status_at(int i, bool value) {
+    Atomic::release_store(RecompilationSchedule::status_adr_at(i), value);
+  }
+  static bool claim_at(int i) {
+    return Atomic::cmpxchg(RecompilationSchedule::status_adr_at(i), false, true) == false;
+  }
+#if INCLUDE_CDS
+  static void iterate_roots(MetaspaceClosure* it);
+  static void cleanup();
+  static void serialize_training_data(SerializeClosure* soc);
+  static void print_archived_training_data_on(outputStream* st);
+#endif
+};
+
+#endif // SHARE_OOPS_RECOMPILATION_SCHEDULE_HPP
diff a/src/hotspot/share/oops/resolvedMethodEntry.cpp b/src/hotspot/share/oops/resolvedMethodEntry.cpp
--- a/src/hotspot/share/oops/resolvedMethodEntry.cpp
+++ b/src/hotspot/share/oops/resolvedMethodEntry.cpp
@@ -63,10 +63,85 @@
     ArchiveBuilder::current()->mark_and_relocate_to_buffered_addr(&_method);
   }
   if (bytecode1() == Bytecodes::_invokeinterface) {
     ArchiveBuilder::current()->mark_and_relocate_to_buffered_addr(&_entry_specific._interface_klass);
   }
+#if 0
+  // OLD CODE ... some of it may need to be salvaged.
+  Bytecodes::Code invoke_code = bytecode_1();
+  if (invoke_code != (Bytecodes::Code)0) {
+    Metadata* f1 = f1_ord();
+    if (f1 != nullptr) {
+      ArchiveBuilder::current()->mark_and_relocate_to_buffered_addr(&_f1);
+      switch (invoke_code) {
+      case Bytecodes::_invokeinterface:
+        assert(0, "not implemented");
+        //assert(f1->is_klass(), "");
+        //ArchiveBuilder::current()->mark_and_relocate_to_buffered_addr(&_f2); // f2 is interface method
+        return false;
+      case Bytecodes::_invokestatic:
+        // For safety, we support invokestatic only for invoking methods in MethodHandle.
+        // FIXME -- further restrict it to linkToStatic(), etc?
+        assert(bytecode_2() == (Bytecodes::Code)0, "must be");
+        assert(f1->is_method(), "");
+        assert(f1_as_method()->method_holder()->name()->equals("java/lang/invoke/MethodHandle") ||
+               f1_as_method()->method_holder()->name()->equals("java/lang/invoke/MethodHandleNatives"), "sanity");
+        return true;
+      case Bytecodes::_invokespecial:
+        assert(f1->is_method(), "must be");
+        // Also need to work on bytecode_2() below.
+        break;
+      case Bytecodes::_invokehandle:
+        assert(bytecode_2() == (Bytecodes::Code)0, "must be");
+        assert(f1->is_method(), "");
+        return true;
+      default:
+        ShouldNotReachHere();
+        break;
+      }
+    }
+  }
+
+  // TODO test case: can invokespecial and invokevirtual share the same CP?
+  invoke_code = bytecode_2();
+  if (invoke_code != (Bytecodes::Code)0) {
+    assert(invoke_code == Bytecodes::_invokevirtual, "must be");
+    if (is_vfinal()) {
+      // f2 is vfinal method
+      ArchiveBuilder::current()->mark_and_relocate_to_buffered_addr(&_f2); // f2 is final method
+    } else {
+      // f2 is vtable index, no need to mark
+      if (DynamicDumpSharedSpaces) {
+        // InstanceKlass::methods() is has been resorted, so we need to
+        // update the vtable_index.
+        int holder_index = src_cp->uncached_klass_ref_index_at(constant_pool_index());
+        Klass* src_klass = src_cp->resolved_klass_at(holder_index);
+        Method* src_m = src_klass->method_at_vtable(f2_as_index());
+        if (!ArchiveBuilder::current()->is_in_mapped_static_archive(src_m->method_holder()) &&
+            !ArchiveBuilder::current()->is_in_mapped_static_archive(src_m)) {
+          Klass* buffered_klass = ArchiveBuilder::current()->get_buffered_addr(src_klass);
+          Method* buffered_m = ArchiveBuilder::current()->get_buffered_addr(src_m);
+          int vtable_index;
+          if (src_m->method_holder()->is_interface()) { // default or miranda method
+            assert(src_m->vtable_index() < 0, "must be");
+            assert(buffered_klass->is_instance_klass(), "must be");
+            vtable_index = InstanceKlass::cast(buffered_klass)->vtable_index_of_interface_method(buffered_m);
+            assert(vtable_index >= 0, "must be");
+          } else {
+            vtable_index = buffered_m->vtable_index();
+            assert(vtable_index >= 0, "must be");
+          }
+          if (_f2 != vtable_index) {
+            log_trace(cds, resolve)("vtable_index changed %d => %d", (int)_f2, vtable_index);
+            _f2 = vtable_index;
+          }
+        }
+      }
+    }
+  }
+
+#endif
 }
 #endif
 
 void ResolvedMethodEntry::print_on(outputStream* st) const {
   st->print_cr("Method Entry:");
diff a/src/hotspot/share/oops/symbol.hpp b/src/hotspot/share/oops/symbol.hpp
--- a/src/hotspot/share/oops/symbol.hpp
+++ b/src/hotspot/share/oops/symbol.hpp
@@ -156,10 +156,13 @@
   unsigned identity_hash() const {
     unsigned addr_bits = (unsigned)((uintptr_t)this >> LogBytesPerWord);
     return ((unsigned)extract_hash(_hash_and_refcount) & 0xffff) |
            ((addr_bits ^ (length() << 8) ^ (( _body[0] << 8) | _body[1])) << 16);
   }
+  static unsigned identity_hash(const Symbol* symbol_or_null) {
+    return symbol_or_null == nullptr ? 0 : symbol_or_null->identity_hash();
+  }
 
   // Reference counting.  See comments above this class for when to use.
   int refcount() const { return extract_refcount(_hash_and_refcount); }
   bool try_increment_refcount();
   void increment_refcount();
@@ -245,10 +248,23 @@
 
   // Three-way compare for sorting; returns -1/0/1 if receiver is </==/> than arg
   // note that the ordering is not alfabetical
   inline int fast_compare(const Symbol* other) const;
 
+  // Perform a memcmp against the other block of bytes, up to the end
+  // of the shorter of the two.  If lengths differ but the bytes are
+  // the same, the shorter one compares lower.
+  int cmp(const Symbol* other) const {
+    return cmp((char*)other->base(), other->utf8_length());
+  }
+  int cmp(const char* str, int len) const {
+    int mylen = utf8_length();
+    int cmp = memcmp((char*)base(), str, mylen < len ? mylen : len);
+    // mylen - len cannot overflow because symbol length >= 0
+    return cmp != 0 ? cmp : mylen - len;
+  }
+
   // Returns receiver converted to null-terminated UTF-8 string; string is
   // allocated in resource area, or in the char buffer provided by caller.
   char* as_C_string() const;
   char* as_C_string(char* buf, int size) const;
 
